<?php
/**
* @version $Id: mod_sfade2.php, v2 2006/02/15
* @package XFade2 : Steve - steve@slayeroffice.com
* @copyright (C) 2006 SlayerOffice
*/

/* Adaptation pour Joomla 1.5 par www.antevox.fr */

// no direct access
defined('_JEXEC') or die('Restricted access');

$attente_affichage	= $params->get( 'attente_affichage', 2000 );
$attente_fondu	= $params->get( 'attente_fondu', 70 );

$largeur	= $params->get( 'largeur', 220 );
$hauteur	= $params->get( 'hauteur', 150 );

$cheminImages = $params->get( 'cheminImages', 'images/stories/fruit');

$attributALT = $params->get( 'attributALT', '');
$attributTITLE = $params->get( 'attributTITLE', '');


// LISTE DES IMAGES DU DOSSIER CHOISI
      
      // Création d'un pointeur vers le dossier
      // (pas d'utilisation de @opendir pour éviter message d'erreur si dossier inexistant,
      //  sinon page blanche sans aucune indication - mieux vaut un message qui indique quel module est en erreur )
      $dir = opendir($cheminImages);
      if (!$dir) exit;   // die ou exit sont équivalents => arrêt du programme si le dossier n'existe pas
      
      // Recherche des images dans ce dossier :
      // => les noms des fichiers avec chemin sont placés dans un tableau
      $tab_images = array();
      // ----------------------------------------------------------------
      // Pour chacun des fichiers présents dans le dossier auquel est associé le pointeur $dir
      while($fichier = readdir($dir)) {
      $fichieravecchemin = $cheminImages."/".$fichier;
         
         // Si c'est un fichier
         if(is_file($fichieravecchemin)) {  // ou if( $file != '.' && $file != '..' && !is_dir($dirname.$file) ) {
            
            // Si c'est une extension d'image compressée
            $ext = strtolower(substr($fichier, strrpos($fichier, '.') + 1));
            if( ($ext=="jpg") || ($ext=="jpeg") || ($ext=="gif") || ($ext=="png")) {
                   
                   $tab_images[] = $fichieravecchemin;
            }
         }
      }
      closedir($dir); // Fermeture du dossier
      
      
      // Tri des images par ordre alphabétique, si ce tableau d'images n'est pas vide
      if (sizeof($tab_images) != 0) {
            sort($tab_images);
      }
?>


<script type="text/javascript">
<!--
/*****

Image Cross Fade Redux
Version 1.0
Last revision: 02.15.2006
steve@slayeroffice.com

Please leave this notice intact. 

Rewrite of old code found here: http://slayeroffice.com/code/imageCrossFade/index.html

*****/

window.addEventListener?window.addEventListener("load",so_init,false):window.attachEvent("onload",so_init);

/* ================================================================================================ */

var d=document, imgs = new Array(), zInterval = null, current=0, pause=false;

function so_init() {
	if(!d.getElementById || !d.createElement)return;

	imgs = d.getElementById("imageContainer").getElementsByTagName("img");
	for(i=1;i<imgs.length;i++) imgs[i].xOpacity = 0;
	imgs[0].style.display = "block";
	imgs[0].xOpacity = .99;
	
	setTimeout(so_xfade,<?php echo $attente_affichage?>);
}

function so_xfade() {
	cOpacity = imgs[current].xOpacity;
	nIndex = imgs[current+1]?current+1:0;

	nOpacity = imgs[nIndex].xOpacity;
	
	cOpacity-=.05; 
	nOpacity+=.05;
	
	imgs[nIndex].style.display = "block";
	imgs[current].xOpacity = cOpacity;
	imgs[nIndex].xOpacity = nOpacity;
	
	setOpacity(imgs[current]); 
	setOpacity(imgs[nIndex]);
	
	if(cOpacity<=0) {
		imgs[current].style.display = "none";
		current = nIndex;
		setTimeout(so_xfade,<?php echo $attente_affichage?>);
	} else {
		setTimeout(so_xfade,<?php echo $attente_fondu?>);
	}
	
	function setOpacity(obj) {
		if(obj.xOpacity>.99) {
			obj.xOpacity = .99;
			return;
		}
		obj.style.opacity = obj.xOpacity;
		obj.style.MozOpacity = obj.xOpacity;
		obj.style.filter = "alpha(opacity=" + (obj.xOpacity*100) + ")";
	}
	
}

//-->
</script>

<!-- Début du bloc <div> qui contiendra les images du fondu-enchaîné (avec obligatoirement id="imageContainer") -->
<div id="imageContainer" style="position: relative; width: <?php echo $largeur?>px; height: <?php echo $hauteur?>px;">

<?php  

$nbimages = count($tab_images);
if ( $nbimages == 0) {
   echo "</div><!-- Fin <div id='imageContainer' ...> -->";
   exit;
}


// Ecriture de la balise pour la première image (avec "display: block;") :
/* pour toutes les images, style en ligne "display: none;"
   sauf pour la première image : "display: block;" pour qu'elle s'affiche seule si Javascript désactivé */
$srcimage = $tab_images[0];
echo "<img src=\"".$srcimage."\" alt=\"".$attributALT."\" title=\"".$attributTITLE."\" style=\"position: absolute; top: 0; left: 0; width: ".$largeur."; height: ".$hauteur."; display: block;\" />"; 

if ( $nbimages == 1) {
   echo "</div><!-- Fin <div id='imageContainer' ...> -->";
   exit;
}


// Ecriture des balises images suivantes
// (même balise que pour la première image, sauf display: none; dans le style en ligne)
for ($i=1; $i<$nbimages; $i++) {
  $srcimage = $tab_images[$i];
  echo "<img src=\"".$srcimage."\" alt=\"".$attributALT."\" title=\"".$attributTITLE."\" style=\"position: absolute; top: 0; left: 0; width: ".$largeur."; height: ".$hauteur."; display: none;\" />"; 
}

?>

</div><!-- Fin <div id="imageContainer" ...> -->
